##################################################################################################
##                                                                                              ##
##  >> Constants <<                                                                             ##
##  This module is a part of the X-Forum CGI software program.                                  ##
##                                                                                              ##
##  Copyright (c) 2001 Diederik van der Boor - All Rights Reserved                              ##
##                                                                                              ##
##################################################################################################


use strict;

$VERSIONS{'constants.pl'} = 'Release 1.6';

##################################################################################################
## Define constants for database routines.

sub ID(){0} # Should be 0!!!

sub DB_SUBJECT_TITLE(){1}
sub DB_SUBJECT_DESCRIPTION(){2}
sub DB_SUBJECT_MODERATORS(){3}
sub DB_SUBJECT_TOPICNUM(){4}
sub DB_SUBJECT_LASTPOSTER(){5}
sub DB_SUBJECT_LASTPOSTDATE(){6}
sub DB_SUBJECT_GROUPS(){7}
sub DB_SUBJECT_LASTPOSTTOPIC(){8}
sub DB_SUBJECT_ICON(){9}

sub DB_SUBJECT_FIELDS(){10} # 0-8 is 9


sub DB_TOPIC_SUBJECT(){1}
sub DB_TOPIC_TITLE(){2}
sub DB_TOPIC_CREATOR(){3}
sub DB_TOPIC_DATE(){4}
sub DB_TOPIC_LOCKED(){5}
sub DB_TOPIC_POSTNUM(){6}
sub DB_TOPIC_VIEWS(){7}
sub DB_TOPIC_LASTPOSTER(){8}
sub DB_TOPIC_LASTPOSTDATE(){9}
sub DB_TOPIC_ICON(){10}
sub DB_TOPIC_STICKY(){11}

sub DB_TOPIC_FIELDS(){12}


sub DB_POST_TITLE(){0}
sub DB_POST_POSTER(){1}
sub DB_POST_DATE(){2}
sub DB_POST_LASTMODMEMBER(){3}
sub DB_POST_LASTMODDATE(){4}
sub DB_POST_IP(){5}
sub DB_POST_ICON(){6}

sub DB_POST_FIELDS(){7}

sub DB_MEMBER_NAME(){1}
sub DB_MEMBER_PASSWORD(){2}
sub DB_MEMBER_EMAIL(){3}
sub DB_MEMBER_PRIVATE(){4}
sub DB_MEMBER_GENDER(){5}
sub DB_MEMBER_COUNTRY(){6}
sub DB_MEMBER_WEBURL(){7}
sub DB_MEMBER_URLTITLE(){8}
sub DB_MEMBER_ICON(){9}
sub DB_MEMBER_ICONTITLE(){10}
sub DB_MEMBER_ICQ(){11}
sub DB_MEMBER_AIM(){12}
sub DB_MEMBER_YIM(){13}
sub DB_MEMBER_POSTNUM(){14}
sub DB_MEMBER_MSN(){15}
sub DB_MEMBER_BIRTHDAY(){16}
sub DB_MEMBER_BIRTHMONTH(){17}
sub DB_MEMBER_BIRTHYEAR(){18}
sub DB_MEMBER_TIMEZONE(){19}
sub DB_MEMBER_REGDATE(){20}
sub DB_MEMBER_LASTPOSTDATE(){21}
sub DB_MEMBER_LASTLOGINDATE(){22}
sub DB_MEMBER_LASTMSG_RECVDATE(){23}
sub DB_MEMBER_LASTMSG_VIEWDATE(){24}
sub DB_MEMBER_MOREINFO(){25}

sub DB_MEMBER_FIELDS(){26}


sub DB_GROUP_TITLE(){1}
sub DB_GROUP_MEMBERS(){2}

sub DB_GROUP_FIELDS(){2} # 0 members allowed


sub DB_MSG_TITLE(){0}
sub DB_MSG_SENDER(){1}
sub DB_MSG_SENTTO(){1} # Same, but for sent messages
sub DB_MSG_DATE(){2}
sub DB_MSG_ICON(){3}

sub DB_MSG_FIELDS(){4}

sub MSG_TYPE_INBOX(){0}
sub MSG_TYPE_SENT(){1}


# Get a new ID
sub DB_STAT_TOPICID(){0}
sub DB_STAT_MSGID(){1}

# Read one of the stats
sub DB_STAT_TOPICNUM(){2}
sub DB_STAT_POSTNUM(){3}
sub DB_STAT_MEMBERNUM(){4}
sub DB_STAT_GUESTPOSTNUM(){5}
sub DB_STAT_NEWMEMBER(){6}
sub DB_STAT_NEWMEMBERDATE(){7}

sub DB_STAT_FIELDS(){8}


# Notification files
sub DB_NOTIFY_MEMBER(){0}
sub DB_NOTIFY_PREVDATE(){1}

# lasterr.log
sub ERROR_LAST(){0}
sub ERROR_EMAIL(){1}




##################################################################################################
## ID's for language packs. (are being converted to inline subroutines by perl)

# Array index 0 should be left empty.
sub FORUM_EMPTY(){1}
#sub FORUM_EMPTY_ADMIN(){2}
sub FORUM_LOCKED(){3}
sub FORUM_TIME(){4}
sub FORUM_WELCOME1(){5}
sub FORUM_WELCOME2(){6}
sub FORUM_WELCOME3(){7}
sub FORUM_WELCOME4(){8}
sub FORUM_WELCOME5(){9}
sub BUTTON_HOME(){10}
sub BUTTON_SEARCH(){11}
sub BUTTON_HELP(){12}
sub BUTTON_PROFILE(){13}
sub BUTTON_REGISTER(){14}
sub BUTTON_ADMIN(){15}
sub BUTTON_LOGFILE(){16}
sub BUTTON_LOGIN(){17}
sub BUTTON_LOGOUT(){18}
sub BUTTON_NEWTOPIC(){19}
sub BUTTON_ADDPOST(){20}
sub BUTTON_LOCK(){21}
sub BUTTON_UNLOCK(){22}
sub BUTTON_EMAIL(){23}
sub BUTTON_QUOTE(){24}
sub BUTTON_EDITPOST(){25}
sub BUTTON_EDITMEMBER(){26}
sub BUTTON_HOME_INFO(){27}
sub BUTTON_SEARCH_INFO(){28}
sub BUTTON_HELP_INFO(){29}
sub BUTTON_PROFILE_INFO(){30}
sub BUTTON_PROFILE_YOU(){31}
sub BUTTON_REGISTER_INFO(){32}
sub BUTTON_ADMIN_INFO(){33}
sub BUTTON_LOGFILE_INFO(){34}
sub BUTTON_LOGIN_INFO(){35}
sub BUTTON_LOGOUT_INFO(){36}
sub BUTTON_NEWTOPIC_INFO(){37}
sub BUTTON_ADDPOST_INFO(){38}
sub BUTTON_LOCK_INFO(){39}
sub BUTTON_UNLOCK_INFO(){40}
sub BUTTON_QUOTE_INFO(){41}
sub BUTTON_EDITPOST_INFO(){42}
sub BUTTON_EDITMEMBER_INFO(){43}
sub BUTTON_MOVE(){44}
sub BUTTON_MOVETOPIC_INFO(){45}
sub GROUP_GENERAL(){46}
sub GROUP_INTERNET(){47}
sub GROUP_WEBSITE(){48}
sub GROUP_MESSENGING(){49}
sub GROUP_FORUMDISP(){50}
sub GROUP_ACCOUNTINFO(){51}
sub GROUP_PERSONAL(){52}
sub GROUP_LICENCE(){53}
sub GROUP_MESSAGE(){54}
sub GROUP_SUBJECTS(){55}
sub ACTION_REGISTER(){56}
sub ACTION_LOGIN(){57}
sub ACTION_CREATE(){58}
sub ACTION_CHANGE(){59}
sub ACTION_SAVE(){60}
sub ACTION_MOVE(){61}
sub ACTION_MORE(){62}
sub ACTION_POST(){63}
sub ACTION_PREVIEW(){64}
sub ACTION_RESET(){65}
sub ACTION_GOBACK(){66}
sub ACTION_RETURN(){67}
sub ACTION_AGREE(){68}
sub ACTION_DECLINE(){69}
sub ERROR_NORMAL(){70}
sub ERROR_SECURITY(){71}
sub ERROR_GENERAL(){72}
sub ERROR_STARTPAGE(){73}
sub ERROR_REDIRECT(){74}
sub ERROR_HELP1(){75}
sub ERROR_HELP2(){76}
sub ERROR_ADMINLOGIN(){77}
sub ERROR_PASSWORD(){78}
sub ERROR_INPUTREQ(){79}
sub ERROR_SIZE1(){80}
sub ERROR_SIZE2(){81}
sub ERROR_SIZE3(){82}
sub ERROR_NUMBER1(){83}
sub ERROR_NUMBER2(){84}
sub ERROR_NUMBER3(){85}
sub ERROR_RANGE(){86}
sub ERROR_URL1(){87}
sub ERROR_URL2(){88}
sub ERROR_URLREQ(){89}
sub ERROR_EMAIL1(){90}
sub ERROR_EMAIL2(){91}
sub ERROR_PASSLEN(){92}
sub ERROR_PASSNE(){93}
sub ERROR_PATHLOC1(){94}
sub ERROR_PATHLOC2(){95}
sub ERROR_BACK1(){96}
sub ERROR_BACK2(){97}
sub ERROR_BACK3(){98}
sub ERROR_LOGIN(){99}
sub ERROR_FLOOD1(){100}
sub ERROR_FLOOD2(){101}
sub HTML_FOOTER1(){102}
sub HTML_FOOTER2(){103}
sub HTML_SUPERVISION(){104}
sub HTML_WEBMASTER(){105}
sub HTML_WEBMASTER_X(){106}
sub HTML_MEMBERICON(){107}
sub HTML_MAILTO(){108}
sub HTML_PRIVATEEMAIL(){109}
sub HTML_EMAILHIDDEN(){110}
sub HTML_ICQADD(){111}
sub HTML_AIM(){112}
sub HTML_AIMSEND(){113}
sub HTML_YIM(){114}
sub HTML_YIMSEND(){115}
sub HTML_NA(){116}
sub XBBC_BOLD(){117}
sub XBBC_ITALICS(){118}
sub XBBC_UNDERLINE(){119}
sub XBBC_STRIKE(){120}
sub XBBC_ALIGNLEFT(){121}
sub XBBC_ALIGNCENTER(){122}
sub XBBC_ALIGNRIGHT(){123}
sub XBBC_ALIGNJUSTIFY(){124}
sub XBBC_FONTFULL(){125}
sub XBBC_FONTFACE(){126}
sub XBBC_FONTCOLOR(){127}
sub XBBC_FONTSIZE(){128}
sub XBBC_QUOTETEXT(){129}
sub XBBC_CODELINES(){130}
sub XBBC_NOMARKUP(){131}
sub XBBC_TYPEWRITER(){132}
sub XBBC_SUBSCRIPT(){133}
sub XBBC_SUPERSCRIPT(){134}
sub XBBC_BULLETLIST(){135}
sub XBBC_ENUMLIST(){136}
sub XBBC_INDENT(){137}
sub XBBC_HORLINE(){138}
sub XBBC_MOVETEXT(){139}
sub XBBC_TABLE(){140}
sub XBBC_TABLEROW(){141}
sub XBBC_TABLECELL(){142}
sub XBBC_URLHTTP(){143}
sub XBBC_URLMAILTO(){144}
sub XBBC_URLFTP(){145}
sub XBBC_IMAGE(){146}
sub XBBC_FLASH(){147}
sub XBBC_SHADOW(){148}
sub XBBC_GLOWTEXT(){149}
sub XBBC_HAPPY(){150}
sub XBBC_WINK(){151}
sub XBBC_CHEESY(){152}
sub XBBC_SAD(){153}
sub XBBC_ANGRY(){154}
sub XBBC_GRIN(){155}
sub XBBC_KISS(){156}
sub XBBC_COOL(){157}
sub XBBC_CRY(){158}
sub XBBC_TONGUE(){159}
sub XBBC_EMBARASSED(){160}
sub XBBC_SHOCKED(){161}
sub XBBC_CONFUSED(){162}
sub XBBC_ROLLEYES(){163}
sub XBBC_UNDECIDED(){164}
sub XBBC_MOUTHSHUT(){165}
sub XBBC_MESSAGE(){166}
sub XBBC_TOOLBAR(){167}
sub XBBC_SELECT(){168}
sub XBBC_INSERT(){169}
sub GUEST_NONE(){170}
sub GUEST_SINGLE(){171}
sub GUEST_MORE(){172}
sub GUEST_LOGIN_REQUEST(){173}
sub SUBTITLE_MEMBER(){174}
sub MEMBER_UNKNOWN(){175}
sub MEMBER_LOGINNAME(){176}
sub MEMBER_GENDER(){177}
sub MEMBER_GENDER_M(){178}
sub MEMBER_GENDER_F(){179}
sub MEMBER_GENDER_X(){180}
sub MEMBER_COUNTRY(){181}
sub MEMBER_TIMEZONE(){182}
sub MEMBER_LASTPOST(){183}
sub MEMBER_REGDATE(){184}
sub MEMBER_TIME(){185}
sub MEMBER_BIRTHDAY(){186}
sub MEMBER_WEBSITE(){187}
sub MEMBER_WEBSITE_U(){188}
sub MEMBER_WEBSITE_N(){189}
sub MEMBER_EMAIL(){190}
sub MEMBER_ICQ(){191}
sub MEMBER_MSN(){192}
sub MEMBER_AIM(){193}
sub MEMBER_YIM(){194}
sub MEMBER_DISPNAME(){195}
sub MEMBER_ICON(){196}
sub MEMBER_ICONTITLE(){197}
sub MEMBER_POSTS(){198}
sub MEMBER_FOOTER(){199}
sub MEMBER_EMPTY(){200}
sub MEMBER_EMAIL_HIDE(){201}
sub MEMBER_HIDECHECK(){202}
sub MEMBER_HIDEINFO(){203}
sub MEMBER_WELCOME(){204}
sub MEMBER_WELCOMEINFO(){205}
sub MEMBER_ISPRIVATE(){206}
sub MEMBER_ABUSE(){207}
sub MEMBER_POSTER(){208}
sub MEMBER_ADMIN(){209}
sub MEMBER_MODERATOR(){210}
sub VISITOR_LIST(){211}
sub MEMBER_NOTEXIST(){212}
sub MEMBER_NOACCESS(){213}
sub MEMBER_BANNED(){214}
sub SUBTITLE_MEMBERLIST(){215}
sub MEMBERLIST_INDEX(){216}
sub MEMBERLIST_NAME(){217}
sub MEMBERLIST_INTERNET(){218}
sub MEMBERLIST_EMPTY(){219}
sub GROUP_NOTEXIST(){220}
sub GROUP_EVERYONE(){221}
sub ISNUM_PAGE(){222}
sub PAGE_OVERFLOW(){223}
sub PAGE_CURRENT(){224}
sub PAGE_COUNT(){225}
sub SUBTITLE_SUBJECT(){226}
sub SUBJECT_TITLE(){227}
sub SUBJECT_DESCRIPTION(){228}
sub SUBJECT_MODERATORS(){229}
sub SUBJECT_EMPTY(){230}
sub SUBJECT_NOTEXIST(){231}
sub SUBJECT_LIST(){232}
sub TOPIC(){233}
sub SUBTITLE_TOPIC(){234}
sub TOPIC_NUM(){235}
sub TOPIC_TITLE(){236}
sub TOPIC_VIEWS(){237}
sub TOPIC_REPLIES(){238}
sub TOPIC_STARTEDBY(){239}
sub TOPIC_LASTPOST(){240}
sub TOPIC_NORMAL(){241}
sub TOPIC_HOT(){242}
sub TOPIC_VERYHOT(){243}
sub TOPIC_LOCKED(){244}
sub TOPIC_ISLOCKED(){245}
sub TOPIC_EMPTY(){246}
sub TOPIC_STARTED(){247}
sub TOPIC_NOTEXIST(){248}
sub SUBTITLE_ADDTOPIC(){249}
sub ADDTOPIC_TITLE(){250}
sub POST_REPLY(){251}
sub POST_ADDED(){252}
sub POST_LASTMOD(){253}
sub POST_BY(){254}
sub POST_NOTEXIST(){255}
sub POST_QUOTE1(){256}
sub POST_QUOTE2(){257}
sub POST_QUOTE3(){258}
sub POST_QUOTE4(){259}
sub SUBTITLE_ADDPOST(){260}
sub ADDPOST_QUOTEEND(){261}
sub ADDPOST_PREFIX(){262}
sub SUBTITLE_EDITPOST(){263}
sub SUBTITLE_LOCK(){264}
sub LOCK_CONFIRM(){265}
sub LOCK_CONFIRMUN(){266}
sub SUBTITLE_LOGIN(){267}
sub SUBTITLE_LOGIN2(){268}
sub LOGIN_REGTIP(){269}
sub LOGIN_EXITTIP(){270}
sub LOGIN_ACCOUNT(){271}
sub LOGIN_PASSWORD(){272}
sub LOGIN_WAIT(){273}
sub LOGIN_TEST(){274}
sub LOGIN_ALT1(){275}
sub LOGIN_ALT2(){276}
sub LOGIN_ALT3(){277}
sub LOGIN_ENTERTEST(){278}
sub LOGIN_FAIL(){279}
sub SUBTITLE_REGISTER(){280}
sub REGISTER_LOGIN(){281}
sub REGISTER_PASS1(){282}
sub REGISTER_PASS2(){283}
sub REGISTER_LICENCE(){284}
sub REGISTER_EXISTS(){285}
sub REGISTER_CHOOSE(){286}
sub REGISTER_NOTAGREE(){287}
sub REGISTER_IDCHAR(){288}
sub REGISTER_LICENCE1(){289}
sub REGISTER_LICENCE2(){290}
sub REGISTER_LICENCE3(){291}
sub REGISTER_LICENCE4(){292}
sub REGISTER_LICENCE5(){293}
sub REGISTER_LICENCE6(){294}
sub SUBTITLE_EDITMEMBER(){295}
sub EDITMEMBER_LOGIN(){296}
sub EDITMEMBER_NOJS(){297}
sub EDITMEMBER_HOWTO1(){298}
sub EDITMEMBER_HOWTO2(){299}
sub EDITMEMBER_HOWTO3(){300}
sub EDITMEMBER_ICON(){301}
sub SUBTITLE_LOGOUT(){302}
sub SUBTITLE_LOGOUT2(){303}
sub LOGOUT_WAIT(){304}
sub LOGOUT_RETURN(){305}
sub SUBTITLE_ICONLIST(){306}
sub ICONLIST_HOWTO1(){307}
sub ICONLIST_HOWTO2(){308}
sub ICONLIST_EMPTY(){309}
sub ICONLIST_NOJS(){310}
sub ICONLIST_FAIL1(){311}
sub ICONLIST_FAIL2(){312}
sub ICONLIST_FAIL3(){313}
sub SUBTITLE_MOVETOPIC(){314}
sub SUBTITLE_PREVIEW(){315}
sub PREVIEW_TITLE(){316}
sub SUBTITLE_HELP(){317}
sub HELP_TOPICS(){318}
sub HELP_MORE1(){319}
sub HELP_MORE2(){320}
sub HELP_MORE3(){321}
sub HELP_UNAVAILABLE(){322}
sub SUBTITLE_CONFIRM(){323}
sub CONFIRM_YES(){324}
sub CONFIRM_NO(){325}


sub ADDPOST_TITLE(){326}
sub BUTTON_DELETE(){327}
sub BUTTON_DELETE_INFO(){328}
sub SUBTITLE_DELPOST(){329}
sub DELPOST_CONFIRM(){330}
sub POST_QUOTE5(){331}
sub SUBTITLE_DELTOPIC(){332}
sub DELTOPIC_CONFIRM(){333}
sub MEMBER_LASTLOGIN(){334}
sub MEMBER_ONLINE(){335}
sub MOVETOPIC_NONE(){336}
sub XBBC_ICON(){337}

sub FORM_EMAIL(){338}
sub FORM_FILLIN(){339}
sub FORM_INT(){340}
sub FORM_UINT(){341}
sub FORM_FLOAT(){342}
sub MEMBER_NOICON(){343}

sub BUTTON_MESSAGES(){344}
sub BUTTON_MESSAGES_INFO(){345}
sub SUBTITLE_INBOX(){346}
sub SUBTITLE_SENTMSG(){347}
sub SUBTITLE_COMPOSE(){348}
sub MESSAGES_NONE(){349}
sub BUTTON_COMPOSEMSG(){350}
sub BUTTON_COMPOSEMSG_INFO(){351}
sub BUTTON_SENTMSG(){352}
sub BUTTON_SENTMSG_INFO(){353}
sub FORWARD_PREFIX(){354}
sub BUTTON_FORWARD(){355}
sub BUTTON_FORWARD_INFO(){356}
sub BUTTON_REPLY(){357}
sub BUTTON_REPLY_INFO(){358}
sub MESSAGE_NOTEXIST(){359}
sub MESSAGE_RECEIVED(){360}
sub MESSAGE_TITLE(){361}
sub MESSAGE_SENDER(){362}
sub MESSAGE_SENTBY(){363}
sub ACTION_SEND(){364}
sub MESSAGE_MAXTO(){365}

sub SUBTITLE_DELMSG(){366}
sub DELMSG_CONFIRM(){367}
sub MESSAGE_SAVESENT(){368}
sub MESSAGE_SAVEINFO(){369}
sub MESSAGE_SENTTO(){370}
sub FORWARD_TO(){371}
sub FORWARD_FROM(){372}
sub FORWARD_SUBJECT(){373}
sub STAT_MEMBERS(){374}
sub STAT_TOPICS(){375}
sub STAT_POSTS(){376}
sub SUBTITLE_FORUM(){377}

sub SUBTITLE_STICK(){378}
sub STICK_CONFIRM(){379}
sub STICK_CONFIRMUN(){380}
sub BUTTON_STICK(){381}
sub BUTTON_UNSTICK(){382}
sub BUTTON_STICK_INFO(){383}
sub BUTTON_UNSTICK_INFO(){384}
sub TOPIC_STICKY(){385}
sub TOPIC_LOCKSTICKY(){386}
sub MESSAGE_SENDTO(){387}
sub MEMBER_ISBANNED(){388}
sub HTML_AIMADD(){389}
sub BUTTON_COMPOSETO(){390}
sub BUTTON_COMPOSETO_INFO(){391}
sub FORUM_NOTIFY1(){392}
sub FORUM_NOTIFY2(){393}
sub FORUM_NOTIFY3(){394}
sub FORUM_NOTIFY4(){395}
sub FORUM_NOTIFY5(){396}
sub NOTIFY_ADDCHECK(){397}
sub NOTIFY_ADD_INFO(){398}
sub NOTIFY_CONFIRMADD(){399}
sub NOTIFY_CONFIRMDEL(){400}
sub GUEST_NOACCESS(){401}
sub HTML_GUEST(){402}
sub GUEST_NONOTIFY(){403}
sub GROUP_GUESTINFO(){404}

sub XBBC_NOJSURL(){405}
sub LOGIN_REENTER1(){406}
sub LOGIN_REENTER2(){407}
sub LOGIN_REENTER3(){408}
sub MEMBERLIST_SORT(){409}
sub MEMBERLIST_REVERSE(){410}
sub MEMBERLIST_DATE(){411}
sub XBBC_SLEEPING(){412}
sub SUBTITLE_SMILEYLIST(){413}
sub SMILEYLIST_HOWTO1(){414}
sub SMILEYLIST_HOWTO2(){415}
sub SMILEYLIST_EMPTY(){416}
sub SMILEYLIST_NOJS(){417}
sub SMILEYLIST_FAIL1(){418}
sub SMILEYLIST_FAIL2(){419}
sub SMILEYLIST_FAIL3(){420}


# Added for X-Forum 1.6
sub SUBTITLE_EDITPASSWORD(){421}
sub GROUP_EDITPASSWORD(){422}
sub BUTTON_EDITPASSWORD(){423}
sub BUTTON_EDITPASSWORD_INFO(){424}
sub PASSWORD_OLD(){425}
sub PASSWORD_ADMIN(){426}
sub EDITPASSWORD_NOADMIN(){427}
sub EDITPASSWORD_LOGIN(){428}

sub ACTION_ADD(){429}
sub ACTION_REMOVE(){430}
sub ACTION_CLOSE(){431}
sub ACTION_SELECT(){432}
sub MEMBER_WELCOME(){433}

sub XBBC_INPUT_FONT(){434}
sub XBBC_INPUT_SIZE(){435}
sub XBBC_INPUT_COLOR(){436}
sub XBBC_INPUT_URL(){437}
sub XBBC_INPUT_WIDTH(){438}
sub XBBC_INPUT_HEIGHT(){439}
sub XBBC_INPUT_CAPTION(){440}
sub XBBC_INPUT_NUMBER(){441}
sub XBBC_INPUT_FILLIN(){442}
sub XBBC_INPUT_TITLE(){443}
sub EDITMEMBER_ICON2(){444}
sub EDITMEMBER_NOURL(){445}
sub HTML_FOOTER2B(){446}
sub XBBC_INPUT_EMAIL(){447}
sub XBBC_INPUT_BADCLR(){448}
sub XBBC_DEVIOUS(){449} # Double constant

sub SUBTITLE_DELMEMBER(){450}
sub DELMEMBER_CONFIRM(){451}
sub SUBTITLE_MOVETOPICS(){452}
sub MOVETOPICS_NONE(){453}
sub BUTTON_MOVEALL(){454}
sub BUTTON_MOVETOPICS_INFO(){455}
sub MEMBER_MOREINFO(){456}
sub LOGIN_REMEMBER(){457}
sub LOGIN_REMEMBER_INFO(){458}